/*
 * Copyright (c) 2005, Your Corporation. All Rights Reserved.
 */

package classUtils.pathUtils;

import utils.SystemUtils;

import java.io.File;

public class NativeLibDetect {
    private String libLocation = null;

    public NativeLibDetect(String libName) {
        libLocation = nativeLibFind(
                System.mapLibraryName(libName),
                SystemUtils.getLibraryPaths());
    }
    public static void checkSerialPort() throws Exception {
        String libName = "rxtxSerial";
        System.out.println("checking lib paths for:"+libName);
        print(SystemUtils.getLibraryPaths());
        if (!isLibInPath(libName))
            notInPathAction(libName);
        else {
            System.out.println("found:"+libName+" "+getPathToLib(libName));
        }
    }

    private static void notInPathAction(String libName) throws Exception {
        System.out.println("could not find:"+libName+" in path");

        throw new Exception("rxtxSerial not in path");
    }

    private static void print(String libraryPaths[]) {
        for (int i=0; i < libraryPaths.length; i++)
            System.out.println(libraryPaths[i]);
    }

    public static boolean isLibInPath(String libName) {
        NativeLibDetect nld = new NativeLibDetect(libName);
        return nld.getLibLocation() != null;
    }

    public static String getPathToLib(String libName) {
        NativeLibDetect nld = new NativeLibDetect(libName);
        return nld.getLibLocation();
    }

    public String nativeLibFind(String libName, String paths[]) {

        for (int i = 0; i < paths.length; i++) {
            File f = new File(paths[i]);
            File fileArray[] = f.listFiles();
            if (fileArray == null) return null;
            for (int j = 0; j < fileArray.length; j++)
                if (fileArray[j].toString().endsWith(libName))
                    return fileArray[j].toString();
        }//outer Loop

        return null;
    }

    public static void main(String[] args) {
        try {
            NativeLibDetect.checkSerialPort();
        } catch (Exception e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }

    public String getLibLocation() {
        return libLocation;
    }
}
